; -----------------------------------------------------------------------------
;	SCA main program
; -----------------------------------------------------------------------------

		.include	"sca_info.asm"
		.include	"bgmdriver_h.asm"

		; sca_player.asm Ē`Ă郋[`̐錾
		.globl	player_init
		.globl	player_stage_init
		.globl	player_move
		.globl	player_shield
		.globl	shot_init
		.globl	shot_move
		.globl	shot_fire
		.globl	sprite_init
		.globl	sprite_update
		.globl	sprite_all_clear
		.globl	enemy_init
		.globl	enemy_start
		.globl	enemy_move
		.globl	enemy_shot_move
		.globl	enemy_init_stage
		.globl	enemy_next_stage
		.globl	check_enemy_clash
		.globl	check_player_clash
		.globl	plant_clash
		.globl	vsync_init
		.globl	vsync_wait_time
		.globl	software_timer
		.globl	score_init
		.globl	score_update
		.globl	score_add
		.globl	top_score_check
		.globl	update_score_ranking
		.globl	sca_title
		.globl	name_entry
		.globl	background_scroll
		.globl	background_init_game_screen
		.globl	background_init_stage_clear_screen
		.globl	background_init_gameover_screen
		.globl	background_draw_stage_x
		.globl	background_update_player_info
		.globl	stage_number
		.globl	background_transfer
		.globl	item_timing
		.globl	player_get_item_check
		.globl	change_palette
		.globl	fade_palette

		.area	CODE (ABS)
		.org	#0x8400

sca_main::
		ld		sp, #0x8300						; X^bN|C^(BASICɂ͖߂Ȃ)
		call	game_init						; e평
sca_main_loop:
		call	sca_title						; ^Cg
		call	state_init						; Q[Jn̏
		call	game_start						; C[v
		call	update_score_ranking			; nCXRAXV
		or		a
		call	nz, name_entry					; nCXRAo^LOO
		call	bgmdriver_stop
		jr		sca_main_loop

; -----------------------------------------------------------------------------
;	
; -----------------------------------------------------------------------------
game_init:
		; MSX turboR ̏ꍇ Z80 [hɐ؂ւ
		ld		a, (MSXVER)
		cp		#3
		jp		c, game_init_skip
		ld		a, #0x80						; [hLEDAZ80[hɐ؂ւ
		call	CHGCPU
game_init_skip:
		; XvCg
		call	sprite_init
		; BGM Driver 
		call	bgmdriver_initialize
		; 荞ݏ
		call	vsync_init
		ret

; -----------------------------------------------------------------------------
;	Q[Ԃ̏
; -----------------------------------------------------------------------------
state_init:
		; _
		call	score_init
		; @
		ld		ix, #player_info
		call	player_init
		; G
		call	enemy_init
		; ACe^C~O
		xor		a
		ld		(item_timing), a
		ret

; -----------------------------------------------------------------------------
;	Xe[WԂ̏
; -----------------------------------------------------------------------------
stage_init:
		; @
		ld		ix, #player_info
		call	player_stage_init
		; @e
		ld		ix, #shot_info0
		call	shot_init
		ld		ix, #shot_info1
		call	shot_init
		ld		ix, #shot_info2
		call	shot_init
		; G
		call	enemy_init_stage
		; pbgݒ
		ld		a, (stage_number)
		and		#7
		call	change_palette
		xor		a
		call	fade_palette
		ret

; -----------------------------------------------------------------------------
;	C[v
; -----------------------------------------------------------------------------
game_start::
		; e평
		call	stage_init							; Q[̓Ԃ
		call	background_init_game_screen			; Q[̔wi
		ld		a, (stage_number)
		call	background_draw_stage_x				; "STAGEx" \
		xor		a
		ld		(stage_clear_flag), a				; Xe[WNAtO
		; Q[BGMtJn
		ld		a, (stage_number)
		and		#7
		rlca
		ld		l, a
		ld		h, #0
		ld		de, #SCA_BGM_TABLE_ADR					; stage  BGM tJn
		add		hl, de
		ld		e, (hl)
		inc		hl
		ld		d, (hl)
		ex		de, hl
		call	bgmdriver_play
game_loop:
		; Q[NAH
		ld		a, (stage_clear_flag)
		or		a
		jp		nz, game_stage_clear				; Xe[WNAQ[I[o[
		; ݂̃^C}[lۑĂ
		ld		a, (software_timer)
		ld		(last_timer), a
		; @eƒn㕨̂蔻菈
		call	plant_clash
		; @ƃACê蔻菈
		call	player_get_item_check
		; wiXN[
		call	background_scroll
		call	background_transfer
		; @̈ړ
		ld		ix, #player_info
		call	player_move
		; @e̔ˏ
		ld		ix, #player_info
		ld		iy, #shot_info0
		call	shot_fire
		; @ëړ
		ld		ix, #shot_info0
		call	shot_move
		ld		ix, #shot_info1
		call	shot_move
		ld		ix, #shot_info2
		call	shot_move
		; @̓蔻菈
		call	check_player_clash
		; G̓蔻菈
		call	check_enemy_clash
		; G̈ړ
		ld		ix, #enemy_info0
		call	enemy_move
		; G̏o
		ld		ix, #player_info
		ld		iy, #enemy_info0
		call	enemy_start
		; Gëړ
		ld		ix, #eshot_info
		call	enemy_shot_move
		; XvCg̕\XV
		ld		ix, #player_info
		call	sprite_update
		; ^C}[lω܂őҋ@
		ld		a, (last_timer)
		ld		hl, #software_timer
game_wait_loop:
		cp		(hl)
		jp		nz, game_loop
		jr		game_wait_loop

; -----------------------------------------------------------------------------
;	Xe[WNA
; -----------------------------------------------------------------------------
game_stage_clear:
		; Q[I[o[f
		dec		a
		jp		nz, game_gameover					; tOQ[I[o[Ăꍇ
		ld		a, (player_shield)					; @ƃ{XɉꂽꍇQ[I[o[
		or		a
		jp		z, game_gameover
		; {XjBGM
		ld		hl, (bgm_clear)
		call	bgmdriver_play
		; {XjBGM~҂
game_stage_clear_loop:
		call	bgmdriver_check_playing
		jr		nz, game_stage_clear_loop
		; ʂNA
		call	background_init_stage_clear_screen	; ʍNA
		call	sprite_all_clear					; XvCgNA
		; ԑ҂
		ld		hl, #30								; 0.5b
		call	vsync_wait_time
		; Xe[WNA{[iX 10000_Z
		ld		b, #10
game_stage_clear_score_loop:
		push	bc
		; 1000_Z
		ld		de, #0x1000
		call	score_add
		call	top_score_check
		call	score_update
		; ʉ
		ld		hl, (se_damage)
		call	bgmdriver_play_sound_effect
		; ԑ҂
		ld		hl, #10								; 0.1b
		call	vsync_wait_time
		pop		bc
		djnz	game_stage_clear_score_loop
		; V[hPZ
		ld		a, (player_shield)
		cp		#9
		jr		z, game_shield_max
		inc		a
		ld		(player_shield), a
		call	background_update_player_info
game_shield_max:
		; ԑ҂
		ld		hl, #60*3							; 3b
		call	vsync_wait_time
		; Gi
		call	enemy_next_stage
		; ̃Xe[WJn
		jp		game_start

; -----------------------------------------------------------------------------
;	Q[I[o[
; -----------------------------------------------------------------------------
game_gameover:
		; ʂNA
		call	background_init_gameover_screen
		call	sprite_all_clear					; XvCgNA
		; Q[I[o[afl
		ld		hl, (bgm_gameover)
		call	bgmdriver_play
		; BGMtI҂
game_gameover_loop:
		call	bgmdriver_check_playing
		jr		nz, game_gameover_loop
		; ԑ҂
		ld		hl, #60*1							; 1b
		call	vsync_wait_time
		ret

; -----------------------------------------------------------------------------
;	Xe[WNA֑J
; -----------------------------------------------------------------------------
goto_next_stage::
		ld		a, #1
		ld		(stage_clear_flag), a
		ret

; -----------------------------------------------------------------------------
;	Q[I[o[֑J
; -----------------------------------------------------------------------------
goto_gameover::
		ld		a, #2
		ld		(stage_clear_flag), a
		ret

; -----------------------------------------------------------------------------
;	[NGA
; -----------------------------------------------------------------------------
last_timer:
		.db		#0

stage_clear_flag:
		.db		#0					; 0: ʏ, 1: Xe[WNA, 2: Q[I[o[

; -----------------------------------------------------------------------------
;	@
; -----------------------------------------------------------------------------
player_info::
		.ds		SCA_INFO_SIZE		; 0
		.ds		SCA_INFO_SIZE		; 1
enemy_info0::
		.ds		SCA_INFO_SIZE		; 2
		.ds		SCA_INFO_SIZE		; 3
enemy_info1::
		.ds		SCA_INFO_SIZE		; 4
		.ds		SCA_INFO_SIZE		; 5
enemy_info2::
		.ds		SCA_INFO_SIZE		; 6
		.ds		SCA_INFO_SIZE		; 7
enemy_info3::
		.ds		SCA_INFO_SIZE		; 8
		.ds		SCA_INFO_SIZE		; 9
enemy_info4::
		.ds		SCA_INFO_SIZE		; 10
		.ds		SCA_INFO_SIZE		; 11
enemy_info5::
		.ds		SCA_INFO_SIZE		; 12
		.ds		SCA_INFO_SIZE		; 13
eshot_info::
		.ds		SCA_INFO_SIZE		; 14	0
		.ds		SCA_INFO_SIZE		; 15	1
		.ds		SCA_INFO_SIZE		; 16	2
		.ds		SCA_INFO_SIZE		; 17	3
		.ds		SCA_INFO_SIZE		; 18	4
		.ds		SCA_INFO_SIZE		; 19	5
		.ds		SCA_INFO_SIZE		; 20	6
		.ds		SCA_INFO_SIZE		; 21	7
		.ds		SCA_INFO_SIZE		; 22	8
		.ds		SCA_INFO_SIZE		; 23	9
		.ds		SCA_INFO_SIZE		; 24	10
		.ds		SCA_INFO_SIZE		; 25	11
		.ds		SCA_INFO_SIZE		; 26	12
		.ds		SCA_INFO_SIZE		; 27	13
		.ds		SCA_INFO_SIZE		; 28	14
shot_info0::
		.ds		SCA_INFO_SIZE		; 29
shot_info1::
		.ds		SCA_INFO_SIZE		; 30
shot_info2::
		.ds		SCA_INFO_SIZE		; 31
